#include <iostream>
#include <conio.h>
#include <vector>
#include <stdlib.h>
using namespace std;
#include "histogram.h"

void
find_minmax(const vector<double>& numbers, double& min, double& max){
    min = numbers[0];
    min = numbers[0];
    for(size_t i=0; i < numbers.size(); i++){
        if (numbers[i] < min)
        {
            min = numbers[i];
        }
        else if (numbers[i] > max)
        {
            max = numbers[i];
        }
    }
}


vector<size_t>
make_histogram(const vector<double>& numbers, size_t bin_count){

    double min, max;
    find_minmax(numbers, min, max);

    vector<size_t> bins(bin_count);

    double bin_size = (max - min) / bin_count;
    for (size_t i = 0; i < numbers.size(); i++)
    {
        bool found = false;
        for (size_t j = 0; (j < bin_count - 1) && !found; j++)
        {
            auto lower_Bound = min + j * bin_size;
            auto upper_Bound = min + (j + 1) * bin_size;
            if ((lower_Bound <= numbers[i]) && (numbers[i] < upper_Bound))
            {
                bins[j]++;
                found = true;
            }
        }
        if (!found)
        {
            bins[bin_count - 1]++;
        }
    }
    return bins;
}

